<?php
/**
 * Step 1: Require the Slim Framework
 *
 * If you are not using Composer, you need to require the
 * Slim Framework and register its PSR-0 autoloader.
 *
 * If you are using Composer, you can skip this step.
 */
require 'Slim/Slim.php';

require_once("idiorm/idiorm.php");

// Connect to the demo database file
//mysql -u fernan13_mon -p7PlXJB0_44tA -h pintacomex.mx

ORM::configure('mysql:host=localhost;port=3306;dbname=fernan13_monitor'); // working environment
ORM::configure('username', 'fernan13_mon');
ORM::configure('password', '7PlXJB0_44tA');
ORM::configure('id_column_overrides', array(
    'licencias' => 'LlaveAct'));
// $app = new Slim();
\Slim\Slim::registerAutoloader();
$app = new \Slim\Slim();
$app->config('debug', false);

/*
ORM::configure('mysql:host=127.0.0.1;port=3306;dbname=fernan13_monitor'); // dev environment
ORM::configure('username', 'root');
ORM::configure('password', '');
ORM::configure('id_column_overrides', array(
    'licencias' => 'LlaveAct'));
\Slim\Slim::registerAutoloader();
$app = new \Slim\Slim();
$app->config('debug', true);
*/

/**
 * Step 3: Define the Slim application routes
 *
 * Here we define several Slim application routes that respond
 * to appropriate HTTP request methods. In this example, the second
 * argument for `Slim::get`, `Slim::post`, `Slim::put`, and `Slim::delete`
 * is an anonymous function.
 */

$app->get('/v1/monitor/servidores/zona/:zona', function ($zona) {
    // Esta funcion entrega los servidores de hasta determinada zona
    $s = ORM::for_table('servidores')->where_lte('zona', $zona)->find_many();
    $res = array();
    foreach($s as $item) {
        $res[] = $item->as_array();
    }
    echo json_encode($res);
});

$app->get('/v1/monitor/servidores/nombre/:nombre', function ($nombre) {
    // Esta funcion busca servidores con el nombre parecido al entregado y en la zona <= 4 para evitar duplicados
    $s = ORM::for_table('servidores')
        ->where_like('Nombre', '%'.$nombre.'%')
        ->where_lte('zona',4)
        ->find_many();
    $res = array();
    foreach($s as $item) {
        $res[] = $item->as_array();
    }
    echo json_encode($res);
});

$app->get('/v1/monitor/marcas/:zona', function ($zona) {
    // Esta puede ser zona 0 (Mexico) o 1 (Tijuana)
    if ( $zona == 0 )
        $strSql = "zona < 4";
    else if ($zona == 1)
        $strSql = "zona = 4";

    $q = "SELECT * FROM ( ";
    $q .= "SELECT Id,Nombre,Ip,Pass,Port,Zona,LastOK ";
    $q .= "FROM marcas as t1 left join servidores on id = idserver ";
    $q .= "WHERE $strSql ORDER BY tiempo DESC LIMIT 1000 ";
    $q .= ") as t2 GROUP BY Nombre ORDER BY Id";
    
    $s = ORM::for_table('marcas')->raw_query($q,array())->find_many();
    $res = array();
    foreach($s as $item) {
        $res[] = $item->as_array();
    }
    echo json_encode($res);
});

$app->get('/v1/monitor/marcas/new/', function () use ($app) {
    // Esta funcion hace el insert de la marca en la base de datos
    $rowEncoded = $app->request()->get('r');
    $rowDecoded = json_decode(urldecode($rowEncoded));
    $row = objectToArray($rowDecoded);
    
    $ret = "{\"Error\":\"1\"}";
    if (count($row)==10) {

        $marca = ORM::for_table('marcas')->create();

        $marca->IdServer = $row['IdServer']; 
        $marca->State = $row['State']; 
        $marca->Slave_IO = $row['Slave_IO'];
        $marca->Slave_SQL = $row['Slave_SQL'];
        $marca->Last_Errno = $row['Last_Errno'];
        $marca->Last_Error = $row['Last_Error']; 
        $marca->Seconds = $row['Seconds']; 
        $marca->master = $row['master'];
        if ($row['LastOK'] == "now()") 
            $marca->lastOK = date("Y-m-d H:i:s");
        else
            $marca->LastOK = $row['LastOK'];
        $marca->posiciones = $row['posiciones'];

        $marca->save();

        $ret = "{\"Error\":\"".$marca->id()."\"}";
    }
    echo $ret;
});

$app->get('/v1/arduino/stamp/new/:hash/:idarduino/:stamp', function ($mac,$idarduino,$stamp) use ($app) {
    // Esta funcion hace el insert del stamp en la tabla del Arduino
    // ej: /v1/arduino/stamp/new/649166638536fd70fddfd3f0657f49a1e5fb982c3f08192d35e27da5d83359a6/33/500

    if ( is_numeric($idarduino) && 
         is_numeric($stamp) && 
         strlen($mac) == 64 &&
         $mac == hash_hmac("sha256",$idarduino."/".$stamp,"82558a389a443c0ea4cc819899f2083a85f0faa3e578f8077a2e3ff46729665b") ) {

        $marca = ORM::for_table('arduinstamps')->create();

        $marca->IdArduino = $idarduino; 
        $marca->Stamp = $stamp; 
        $marca->save();

        echo "{\"Error\":\"".$marca->id()."\"}";
    } else {
        $app->notFound();
    }
});

$app->get('/v1/arduino/stamp/:idarduino', function ($idarduino) {
    // Esta funcion regresa los stamps de un arduino como json
    $res = array();
    if (is_numeric($idarduino)) {
        $q = "SELECT Time,Stamp FROM arduinstamps where IdArduino = $idarduino order by Time asc limit 100";
        $s = ORM::for_table('arduinstamps')->raw_query($q,array())->find_many();
        //$res = $s->as_array();
        foreach($s as $item) {
            $res[] = $item->as_array();
        }
    }
    echo json_encode($res);
});

$app->get('/v1/arduino/stamp/:idarduino/d.tsv', function ($idarduino) {
    // Esta funcion regresa los stamps de un arduino como tsv
    $res = "Time\tStamp\n";
    if (is_numeric($idarduino)) {
        $q = "SELECT Time,Stamp FROM arduinstamps where IdArduino = $idarduino order by Time asc limit 100";
        $s = ORM::for_table('arduinstamps')->raw_query($q,array())->find_many();
        //$res = $s->as_array();
        foreach($s as $item) {
            $res .= $item->Time . "\t" . $item->Stamp . "\n";
        }
    }
    echo $res;
});

$app->get('/v1/arduino/stamp/:idarduino/d.csv', function ($idarduino) {
    // Esta funcion regresa los stamps de un arduino como csv
    $res = "symbol,date,price\n";
    if (is_numeric($idarduino)) {
        $q = "SELECT * FROM arduinstamps where IdArduino = $idarduino order by Time asc limit 100";
        $s = ORM::for_table('arduinstamps')->raw_query($q,array())->find_many();
        //$res = $s->as_array();
        foreach($s as $item) {
            $res .= "Ard " . $item->IdArduino . "," . $item->Time . "," . $item->Stamp . "\n";
        }
    }
    echo $res;
});

$app->get('/arduinos', function () use ($app) {
    // Esta funcion despliega los arduinos existentes
    $res = array();
    $q = "SELECT * FROM arduinstamps group by idArduino order by idArduino asc, Time desc limit 100";
    $s = ORM::for_table('arduinstamps')->raw_query($q,array())->find_many();
    //$res = $s->as_array();
    foreach($s as $item) {
        $res[] = $item->as_array();
    }
    $app->render("arduinos.php", array('res' => $res));
});

$app->get('/arduinos/:idarduino', function ($idarduino) use ($app) {
    // Esta funcion despliega el arduino seleccionado graficado
    $res = array();
    if (is_numeric($idarduino)) {
        $res[] = $idarduino;
    }
    $app->render("arduinosIdArduino3.php", array('res' => $res));
});

$app->run();

function objectToArray($d) {
    if (is_object($d)) {
      // Gets the properties of the given object
      // with get_object_vars function
      $d = get_object_vars($d);
    }
 
    if (is_array($d)) {
      /*
      * Return array converted to object
      * Using __FUNCTION__ (Magic constant)
      * for recursive call
      */
      return array_map(__FUNCTION__, $d);
    }
    else {
      // Return array
      return $d;
    }
}